
public class Queue0 extends Queue
{
	private Node head, tail;
	
	private int size;
	
	public Queue0()
	{
		clear();
	}
	
	public void clear()
	{
		head = tail = null;
		size = 0;
	}
	
	public char get()
	{
		char val = head.val;
		head = head.next;
		size--;
		return val;
	}
	
	public int getSize()
	{
		return size;
	}
	
	public boolean isEmpty()
	{
		return (head == null);
	}
	
	public void print()
	{
		if(isEmpty()) return;
		
		Node n = head;
		do
		{
			Out.print(String.format(" %c", n.val));
			n = n.next;
		}
		while(n != null);
	}
	public void put(char val)
	{
		Node n = new Node(val);
		if(isEmpty())
			head = n;
		else
			tail.next = n;
		tail = n;
		size++;
	}
}
